﻿using Infragistics.Controls.Editors;
using Infragistics.Controls.Editors.Primitives;
using Infragistics.Documents.RichText;
using Infragistics.Windows;
using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace WpfApplication5
{
    /// <summary>
    /// MainWindow.xaml の相互作用ロジック
    /// </summary>
    public partial class MainWindow : Window
    {
        string targetUrl = "http://www.infragistics.com/";
        public MainWindow()
        {
            InitializeComponent();

            string error = null;

            RichTextDocument doc = this.xamRichTextEditor1.Document;
            ParagraphNode pn1 = new ParagraphNode();
            pn1.SetText("Infragistics Website");
            doc.RootNode.Body.ChildNodes.Add(pn1);
            doc.MakeHyperlink(pn1.GetDocumentSpan(), "http://www.infragistics.com/", out error, "Infragistics Website");

            ParagraphNode pn2 = new ParagraphNode();
            pn2.SetText("Infragistics Forum");
            doc.RootNode.Body.ChildNodes.Add(pn2);
            doc.MakeHyperlink(pn2.GetDocumentSpan(), "https://www.infragistics.com/community/forums/", out error, "Infragistics Forum");

        }


        private void editor1_MouseMove(object sender, MouseEventArgs e)
        {
            var adornmentLayer = e.OriginalSource as AdornmentLayer;

            if (adornmentLayer != null)
            {
                Mouse.OverrideCursor = Cursors.Hand;
            }
            else
            {
                Mouse.OverrideCursor = Cursors.Arrow;
            }
        }

        private void xamRichTextEditor1_MouseLeftButtonUp(object sender, MouseButtonEventArgs e)
        {
            var editor = sender as XamRichTextEditor;

            if (editor == null)
            {
                return;
            }

            var docSpan = editor.Selection.DocumentSpan;
            var paragraphs = editor.Document.GetParagraphs(docSpan);

            if (paragraphs.First().ChildNodes == null)
            {
                return;
            }

            var hyperlink = paragraphs.First().ChildNodes.First() as HyperlinkNode;
            if (hyperlink != null)
            {
                if (hyperlink.Uri.Contains("forums"))
                {
                    //DoSomeAction();
                    Process.Start(hyperlink.Uri);
                }
                else
                {
                    //DoAnotherAction();
                    Process.Start(hyperlink.Uri);
                }
            }
        }
    }
}
